// The contents of this file are subject to the Mozilla Public License Version 1.1
// (the "License"); you may not use this file except in compliance with the License.
// You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
// 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
// WARRANTY OF ANY KIND, either express or implied. See the License for the specific
// language governing rights and limitations under the License.
// 
// The Original Code is the Venice Web Communities System.
// 
// The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
// for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
// Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
// 
// Contributor(s): 

importPackage(java.util);
importPackage(Packages.com.silverwrist.venice.core);
importPackage(Packages.com.silverwrist.venice.except);
importPackage(Packages.com.silverwrist.venice.ui);
importPackage(Packages.com.silverwrist.venice.ui.helpers);
importPackage(Packages.com.silverwrist.venice.ui.view);

// get the request object
rinput = bsf.lookupBean("request");

// get the two index values
ndx = rinput.getParameterInt("ndx",-1);
ndx2 = rinput.getParameterInt("ndx2",-1);
if ((ndx<0) || (ndx2<0) || (ndx==ndx2))
{ // index values out of range
  vlib.output(new ErrorBox(null,"Invalid index parameters.","conf/hotlist.js.vs"));
  vlib.done();

} // end if

rc = null;
try
{ // get the hotlist and further check the parameters
  hotlist = rinput.user.getConferenceHotlist();
  if ((ndx>=hotlist.size()) || (ndx2>=hotlist.size()))
    throw new ErrorBox(null,"Invalid index parameters.","conf/hotlist.js.vs");

  // get the hotlist entries
  entry1 = vlib.castConferenceHotlistEntry(hotlist.get(ndx));
  entry2 = vlib.castConferenceHotlistEntry(hotlist.get(ndx2));

  // get the sequence numbers
  seq1 = entry1.getSequence();
  seq2 = entry2.getSequence();

  // now reassign the sequences
  entry1.setHotlistSequence(seq2);
  restore = true;
  try
  { // set the second sequence
    entry2.setHotlistSequence(seq1);
    restore = false;

  } // end try
  finally
  { // restore the first sequence on error
    if (restore)
      entry1.setHotlistSequence(seq1);

  } // end finally

  // bounce back to the hotlist screen
  rc = new Redirect("conf/hotlist.js.vs",LinkTypes.SERVLET);

} // end try
catch (e)
{ // error adjusting the hotlist sequence
  etype = vlib.exceptionType(e) + "";
  if (etype.match("DataException"))
    rc = new ErrorBox("Database Error","Error adjusting hotlist: " + e.message,"conf/hotlist.js.vs");
  else
    rc = e;

} // end catch

vlib.output(rc);  // all done
